subroutine calcsphere(masque,xmax,ymax,zmax,aext,bext,cext,aint,bint,cint,cx,cy,cz,mat,NN)
	integer :: xmax,ymax,zmax,mat
	real :: aext,bext,cext,aint,bint,cint,cx,cy,cz
	integer, INTENT(INOUT) :: masque(0:xmax,0:ymax,0:zmax)

	integer :: i,j,k,NN
	real :: t1,t2,t3

	NN=0
! fix it
!	write(*,*) aint,bint,cint,cx,cy,cz
	
	DO i=0,xmax,1
	DO j=0,ymax,1
	do k=0,zmax,1
	    if ((aint>0).and.(bint>0).and.(cint>0)) then
		t2=((i-cx)*(i-cx)/(aint*aint))+((j-cy)*(j-cy)/(bint*bint))+((k-cz)*(k-cz)/(cint*cint))
	    else
		t2=2
	    end if

	    t1=((i-cx)*(i-cx)/(aext*aext))+((j-cy)*(j-cy)/(bext*bext))+((k-cz)*(k-cz)/(cext*cext))
!	    write(*,*) i,j,k,t1,t2
	    if ((t1<=1.01).and.(t2>=0.99)) then
	    	NN=NN+1
		masque(i,j,k)=mat
	    end if
	end do
	END DO
	END DO
	
end subroutine calcsphere

subroutine calcdisk(masque,xmax,ymax,zmax,aext,bext,aint,bint,height,cx,cy,cz,mat,NN)
! draws the ellips
	integer :: xmax,ymax,zmax,mat
	real :: aext,bext,aint,bint,cx,cy,cz,height
	integer, INTENT(INOUT) :: masque(0:xmax,0:ymax,0:zmax)

	integer :: i,j,k,NN
	real :: t1,t2,t3

	NN=0
!	write(*,*) aext,bext,height
	DO i=0,xmax,1
	DO j=0,ymax,1
	do k=0,zmax,1
	    if ((aint>0).and.(bint>0)) then
		t2=((i-cx)*(i-cx)/(aint*aint))+((j-cy)*(j-cy)/(bint*bint))
	    else
		t2=2
	    end if
!	    write(*,*) i,cx,aext,j,cy,bext
	    t1=((i-cx)*(i-cx)/(aext*aext))+((j-cy)*(j-cy)/(bext*bext))
!	    write(*,*) i,j,k,t1,t2,k-cz
	    if ((t1<=1).and.(t2>=1).and.((k-cz)<=height).and.(k>=cz)) then
	    	NN=NN+1
		masque(i,j,k)=mat
	    end if
	end do
	END DO
	END DO
end subroutine calcdisk

subroutine calcslab(masque,xmax,ymax,zmax,cx,cy,cz,dx,dy,dz,mat,NN)
	integer :: xmax,ymax,zmax,mat
	real :: cx,cy,cz,dx,dy,dz
	integer, INTENT(INOUT) :: masque(0:xmax,0:ymax,0:zmax)

	integer :: i,j,k,NN
	real :: t1,t2,t3

	NN=0
	
	DO i=0,xmax,1
	    DO j=0,ymax,1
			do k=0,zmax,1
				if ((abs(i-cx)<=dx).and.(abs(j-cy)<=dy).and.(abs(k-cz)<=dz)) then
	    			NN=NN+1
					masque(i,j,k)=mat
				end if
			end do
	    END DO
	END DO
end subroutine calcslab

subroutine calcslab2(masque,xmax,ymax,zmax,x1,x2,y1,y2,z1,z2,mat,NN)
	integer :: xmax,ymax,zmax,mat
	integer :: x1,x2,y1,y2,z1,z2
	integer, INTENT(INOUT) :: masque(0:xmax,0:ymax,0:zmax)

	integer :: i,j,k,NN
	real :: t1,t2,t3

	NN=0
	
	DO i=x1,x2,1
	    DO j=y1,y2,1
			do k=z1,z2,1
	    			NN=NN+1
					masque(i,j,k)=mat
				end do
	    END DO
	END DO
end subroutine calcslab2


subroutine loadmasque(masque,xmax,ymax,zmax,fname)
integer :: xmax,ymax,zmax,i
integer, INTENT(INOUT) :: masque(0:xmax,0:ymax,0:zmax)
character(255) :: fname

integer :: j,k,ii,t

inquire(iolength=i) j,j,k,masque(j,j,k)
OPEN(UNIT=999,FILE=fname,STATUS='OLD',ACTION='READ',FORM='UNFORMATTED',ACCESS='DIRECT',RECL=i)

	read(999,REC=1) ii,j,k,t
	do t=2,ii+1,1
		read(999,REC=t) i,j,k,masque(i,j,k)
	end do

CLOSE(999)

end subroutine loadmasque

subroutine loadmasqueparam(xmax,ymax,zmax,fname)
integer :: xmax,ymax,zmax
integer :: i,j,k,t
character(255) :: fname

inquire(iolength=i) j,j,k,t
OPEN(UNIT=999,FILE=fname,STATUS='OLD',ACTION='READ',FORM='UNFORMATTED',ACCESS='DIRECT',RECL=i)
	read(999,REC=1) t,xmax,ymax,zmax
CLOSE(999)

end subroutine loadmasqueparam

subroutine savemasque(masque,xmax,ymax,zmax,fname)
integer:: xmax,ymax,zmax,i
integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax)
character(255) :: fname

integer ::j,k,ii

inquire(iolength=i) ii,j,k,masque(ii,j,k)

OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',ACTION='WRITE',FORM='UNFORMATTED',ACCESS='DIRECT',RECL=i)

ii=1
write(999,REC=ii) (xmax+1)*(ymax+1)*(zmax+1),xmax,ymax,zmax
ii=ii+1
do i=0,xmax,1
  DO j=0,ymax,1
		do k=0,zmax,1
			write(999,REC=ii) i,j,k,masque(i,j,k)
			ii=ii+1
		END DO
	END DO
END DO

CLOSE(999)
end subroutine savemasque

subroutine loadmasquet(masque,xmax,ymax,zmax,fname)
integer :: xmax,ymax,zmax,i,j,k,t,ii
integer, INTENT(INOUT) :: masque(0:xmax,0:ymax,0:zmax)
character(255) :: fname

OPEN(UNIT=999,FILE=fname,STATUS='OLD',ACTION='READ',FORM='FORMATTED')

read(999,'(I7,3I6)') ii,j,k,t
	do t=2,ii+1,1
		read(999,'(3I6,I3)') i,j,k,masque(i,j,k)
	end do

CLOSE(999)

end subroutine loadmasquet

subroutine loadmasqueparamt(xmax,ymax,zmax,fname)
integer :: xmax,ymax,zmax,i,j,k,t,ii
character(255) :: fname

OPEN(UNIT=999,FILE=fname,STATUS='OLD',ACTION='READ',FORM='FORMATTED')

read(999,'(I7,3I6)') ii,xmax,ymax,zmax
	
CLOSE(999)

end subroutine loadmasqueparamt


subroutine savemasquet(masque,xmax,ymax,zmax,fname)
integer :: xmax,ymax,zmax,i,j,k
integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax)
character(255) :: fname

OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',ACTION='WRITE',FORM='FORMATTED')
write(999,'(I7,3I6)') (xmax+1)*(ymax+1)*(zmax+1),xmax,ymax,zmax

do i=0,xmax,1
    DO j=0,ymax,1
		do k=0,zmax,1
		write(999,'(3I6,I3)') i,j,k,masque(i,j,k)
		END DO
	END DO
END DO

CLOSE(999)
end subroutine savemasquet

subroutine savemasquet2(masque,xmax,ymax,zmax,fname)
integer :: xmax,ymax,zmax,i,j,k
integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax)
character(255) :: fname

OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',ACTION='WRITE',FORM='FORMATTED')
write(999,'(I7,3I6)') (xmax+1)*(ymax+1)*(zmax+1),xmax,ymax,zmax

do k=0,zmax,1
    write(999,'(a2,I0)') 'z=',k
    do j=0,ymax,1
	do i=0,xmax,1
	    write(999,'(I1)',ADVANCE='NO') masque(i,j,k)
	end do
    write(999,*)
    end do
end do
    
CLOSE(999)
end subroutine savemasquet2

subroutine loadmasquet2(masque,xmax,ymax,zmax,fname)
integer :: xmax,ymax,zmax,i,j,k,ii,imax,jmax,kmax,t
integer, INTENT(OUT) :: masque(0:xmax,0:ymax,0:zmax)
character(255) :: fname
character(2) :: tt

OPEN(UNIT=999,FILE=fname,STATUS='OLD',ACTION='READ',FORM='FORMATTED')
read(999,'(I7,3I6)') ii,imax,jmax,kmax

do k=0,kmax,1
    read(999,'(a2,I1)') tt,t
    do j=0,jmax,1
	do i=0,imax,1
	    read(999,'(I1)',ADVANCE='NO') masque(i,j,k)
	end do
    read(999,*)
    end do
end do
    
CLOSE(999)
end subroutine loadmasquet2

subroutine get_n(masque,xmax,ymax,zmax,n)
integer :: xmax,ymax,zmax,i,j,k,n
integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax)

    n=0
    DO i=0,xmax,1
    DO j=0,ymax,1
    do k=0,zmax,1
	if (masque(i,j,k).ne.0) n=n+1
    end do
    end do
    end do

end subroutine get_n

