subroutine calcij(tt,ms,mp,beta,masque,aij,m,h,x,y,z,x2,y2,z2,xmax,ymax,zmax,matmax)
    real :: te(1:3,1:3),to(1:3,1:3),tt(1:2,1:2),beta,mp(3)
    integer :: matmax,xmax,ymax,zmax,alpha,phi,be,ga,epsilon(1:3,1:3,1:3)
    real :: ms(matmax), m(0:xmax,0:ymax,0:zmax,1:3), h(0:xmax,0:ymax,0:zmax,1:3)
    real :: aij(-xmax:xmax+1,-ymax:ymax+1,-zmax:zmax+1,1:3,1:3,matmax)
    integer :: x,y,z,x2,y2,z2,masque(0:xmax,0:ymax,0:zmax)
    real :: at(1:3,1:3),at1(1:3,1:3),t1
    integer :: i,j,k
    
    epsilon=0
    
    epsilon(1,2,3)=1
    epsilon(3,1,2)=1
    epsilon(2,3,1)=1
    
    epsilon(1,3,2)=-1
    epsilon(3,2,1)=-1
    epsilon(2,1,3)=-1
    
    call calcmatr(m(x,y,z,1:3),at,1)
    call calcmatr(m(x2,y2,z2,1:3),at1,0)
    te=0
    to=0
    do alpha=1,3
    do phi=1,3
    do be=1,3
    do ga=1,3
	te(alpha,phi)=te(alpha,phi)+epsilon(alpha,be,ga)*m(x,y,z,be)*aij(x-x2,y-y2,z-z2,ga,phi,masque(x2,y2,z2))
    end do
    end do
    end do
    end do

    if ((x.eq.x2).and.(y.eq.y2).and.(z.eq.z2)) then
	do alpha=1,3
	do phi=1,3
	do ga=1,3
	    te(alpha,phi)=te(alpha,phi)+epsilon(alpha,phi,ga)*h(x,y,z,ga)
	end do
	end do
	end do
    end if
    
    to=te
    do alpha=1,3
    do phi=1,3
    do be=1,3
    do ga=1,3
	to(alpha,phi)=to(alpha,phi)+beta*epsilon(alpha,be,ga)*m(x,y,z,be)*te(ga,phi)/ms(masque(x,y,z))
    end do
    end do
    end do
    end do
    
    if ((x.eq.x2).and.(y.eq.y2).and.(z.eq.z2)) then
        t1=0
	do i=1,3
	    t1=t1+m(x,y,z,i)*mp(i)
	end do
	t1=t1/ms(masque(x,y,z))
	
	do alpha=1,3
	    to(alpha,alpha)=to(alpha,alpha)-t1
	end do
    end if

    te=0
    do alpha=1,3
    do phi=1,3
    do be=1,3
    do ga=1,3
        te(alpha,phi)=te(alpha,phi)+at(alpha,be)*to(be,ga)*at1(ga,phi)
    end do
    end do
    end do
    end do	
    tt(1:2,1:2)=te(1:2,1:2)
    
end subroutine calcij

subroutine calcmatrix_ns(m,aij,h,mp,beta,masque,num,xmax,ymax,zmax,ms,matmax,ncells,nmodes,ncv,degr,v,d,nconv)
    real :: tt(1:2,1:2),beta,mp(3)
    integer :: matmax,xmax,ymax,zmax,ncells,be,ga,nmodes,ncv,nconv
    real :: ms(matmax), m(0:xmax,0:ymax,0:zmax,1:3), h(0:xmax,0:ymax,0:zmax,1:3)
    real :: aij(-xmax:xmax+1,-ymax:ymax+1,-zmax:zmax+1,1:3,1:3,matmax)
    integer :: x,y,z,x2,y2,z2,masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
    integer :: degr(1:ncells)
    real :: at(1:3,1:3),at1(1:3,1:3),t1(1:3)
    integer :: ii,ii2
    real :: a(1:2*ncells,1:2*ncells)
    real :: d(ncv,3),v(2*ncells,ncv),time1,time2

    a=0
    call CPU_TIME(time1)
    do x=0,xmax
    do y=0,ymax
    do z=0,zmax
	if (masque(x,y,z).NE.0) then
	    ii=num(x,y,z)
	    do x2=0,xmax
	    do y2=0,ymax
	    do z2=0,zmax
		if (masque(x2,y2,z2).NE.0) then		
		    ii2=num(x2,y2,z2)
		    call calcij(tt,ms,mp,beta,masque,aij,m,h,x,y,z,x2,y2,z2,xmax,ymax,zmax,matmax)
		    do be=1,2
		    do ga=1,2
			a(2*ii-2+be,2*ii2-2+ga)=a(2*ii-2+be,2*ii2-2+ga)+tt(be,ga)
		    end do
		    end do
		end if
	    end do
	    end do
	    end do
	end if 
    end do
    end do
    end do
    
    do ii=1,ncells
    do be=0,1
	a(2*ii-1+be,1:(2*ncells))=a(2*ii-1+be,1:(2*ncells))/real(degr(ii))
    end do
    end do
!    do ii=1,ncells
!    do be=0,1
!	write(15,*) ii,be,a(2*ii-1+be,5)
!    end do
!    end do
!    write(14,*) a(2,500)
    call CPU_TIME(time2)
    write(*,*) "matrix created", time2-time1
    call solvear(a,2*ncells,nmodes,ncv,d,v,nconv)
    call CPU_TIME(time1)
    write(*,*) "matrix solved", time1-time2
end subroutine calcmatrix_ns


subroutine calcmatrix_s(m,aij,h,mp,beta,masque,num,xmax,ymax,zmax,ms,matmax,ncells,nmodes,ncv,cellx,celly,cellz,rcut,v,d,nconv)
    real :: tt(1:2,1:2),beta,mp(3)
    integer :: matmax,xmax,ymax,zmax,ncells,be,ga,nmodes,ncv,nconv
    real :: ms(matmax), m(0:xmax,0:ymax,0:zmax,1:3), h(0:xmax,0:ymax,0:zmax,1:3)
    real :: aij(-xmax:xmax+1,-ymax:ymax+1,-zmax:zmax+1,1:3,1:3,matmax)
    integer :: x,y,z,x2,y2,z2,masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
    real :: at(1:3,1:3),at1(1:3,1:3),t1(1:3)
    integer :: ii,ii2,nelem,iii
    real,allocatable :: a(:)
    integer(kind=2), allocatable :: aindex(:,:)
    real :: d(ncv,3),v(2*ncells,ncv),time1,time2
    real :: cellx,celly,cellz,rcut,r(-xmax:xmax,-ymax:ymax,-zmax:zmax)

    do x=-xmax,xmax
    do y=-ymax,ymax
    do z=-zmax,zmax
	r(x,y,z)=sqrt((x*x*cellx*cellx+y*y*celly*celly+z*z*cellz*cellz))
    end do
    end do
    end do
! now determining number of elements
    nelem=0
    do x=0,xmax
    do y=0,ymax
    do z=0,zmax
	if (masque(x,y,z).NE.0) then
	    do x2=0,xmax
	    do y2=0,ymax
	    do z2=0,zmax
		if ((masque(x2,y2,z2).NE.0).and.(r(x2-x,y2-y,z2-z)<=rcut)) then
		    nelem=nelem+1
		end if
	    end do
	    end do
	    end do
	end if
    end do
    end do
    end do
!    write(*,*) nelem,ncells
    write(*,'(I0,a10,F6.2,a1)') nint(sqrt(real(nelem)))," elements ",100*nelem/real(ncells*ncells),"%"
    allocate(a(4*nelem))
    allocate(aindex(1:4*nelem,1:2))
    a=0
    call CPU_TIME(time1)
    iii=0
    do x=0,xmax
    do y=0,ymax
    do z=0,zmax
	if (masque(x,y,z).NE.0) then
	    ii=num(x,y,z)
	    do x2=0,xmax
	    do y2=0,ymax
	    do z2=0,zmax
		if ((masque(x2,y2,z2).NE.0).and.(r(x2-x,y2-y,z2-z)<=rcut)) then
		    ii2=num(x2,y2,z2)
		    call calcij(tt,ms,mp,beta,masque,aij,m,h,x,y,z,x2,y2,z2,xmax,ymax,zmax,matmax)	    		    
		    do be=1,2
		    do ga=1,2
			iii=iii+1
			a(iii)=a(iii)+tt(be,ga)
			aindex(iii,1)=2*ii-2+be
			aindex(iii,2)=2*ii2-2+ga
		    end do
		    end do
		end if
	    end do
	    end do
	    end do
	end if 
    end do
    end do
    end do
!    write(*,*) iii," elements"    
!     write(15,*) a(1000),aindex(1000,1),aindex(1000,2)
    call CPU_TIME(time2)
    write(*,*) "matrix created", time2-time1
    call solvears(a,aindex,4*nelem,2*ncells,nmodes,ncv,d,v,nconv)
    call CPU_TIME(time1)
    write(*,*) "matrix solved", time1-time2
end subroutine calcmatrix_s

subroutine sort_ar(v,d,modes,w,ncells,ncv,nconv,nmodes)
    integer :: ncells,ncv,nmodes,nconv
    real :: d(ncv,3),v(2*ncells,ncv)
    complex :: w(nmodes),modes(ncells,2,nmodes)
    integer :: i,j,ii,be
    complex, parameter :: im=(0,1)
    
    ii=0
    do i=1,nconv
	if(d(i,2)>0) then
	    ii=ii+1
	    w(ii)=d(i,2)-im*d(i,1)
	    do j=1,ncells
	    do be=0,1
		modes(j,be+1,ii)=v(2*j-1+be,i)+im*v(2*j-1+be,i+1)
	    end do
	    end do
	end if
    end do    
    call sort_modes(w,modes,ncells,nmodes)
end subroutine sort_ar

subroutine sort_modes(w,modes,ncells,nmodes)
    integer :: ncells,nmodes
    complex :: w(nmodes),modes(ncells,2,nmodes)
    integer :: i,j,imax
    complex :: wtemp,modet(ncells,2)
    real :: wmax
    
    do j=nmodes,2,-1
    wmax=-1D200
	do i=1,j
	    if(real(w(i))>wmax) then
		wmax=real(w(i))
		imax=i
	    end if
	end do
	wtemp=w(j)
	modet(:,:)=modes(:,:,j)
	w(j)=w(imax)
	modes(:,:,j)=modes(:,:,imax)
	w(imax)=wtemp
	modes(:,:,imax)=modet(:,:)	
    end do
end subroutine sort_modes