!DEC$ DEFINE rflag=8
subroutine number(masque,num,xmax,ymax,zmax,n,scx,scy,scz)
	integer :: xmax,ymax,zmax,i,j,k,n,i1,j1,k1,scx,scy,scz,chk
	integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax)
	integer, INTENT(OUT) ::num(0:xmax,0:ymax,0:zmax)

	n=0
	num=0
	do i=0,xmax,scx
	do j=0,ymax,scy
	do k=0,zmax,scz
	chk=0
		do i1=0,scx-1,1
		do j1=0,scy-1,1
		do k1=0,scz-1,1
		if (((i+i1)<=xmax).and.((j+j1)<=ymax).and.((k+k1)<=zmax)) then
			if(masque(i+i1,j+j1,k+k1).NE.0) then
				if(chk.eq.0) then
					chk=1
					n=n+1
				end if
				num(i+i1,j+j1,k+k1)=n
			end if
		end if
		end do
		end do
		end do
	end do
	end do
	end do
	
end subroutine number

subroutine number_r(masque,num,xmax,ymax,zmax,n,rscale,cellx,celly,scx,scy,scz)
	integer :: xmax,ymax,zmax,i,j,k,n,i1,j1,k1,scx,scy,scz,chk,nt
	integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax)
	integer, INTENT(OUT) ::num(0:xmax,0:ymax,0:zmax)
	real :: rscale,cellx,celly,r

	nt=0
	num=0
	do i=0,xmax,scx
	do j=0,ymax,scy
	do k=0,zmax,scz
	chk=0
	n=nt
		do i1=0,scx-1,1
		do j1=0,scy-1,1
		do k1=0,scz-1,1
! calculate the distance from the center
		    if((((i+i1)<=xmax).and.((j+j1)<=ymax).and.((k+k1)<=zmax))) then
		    if(masque(i+i1,j+j1,k+k1).NE.0) then
			r=cellx*cellx*(i+i1-real(xmax)/2)*(i+i1-real(xmax)/2)+(j+j1-real(ymax)/2)*(j+j1-real(ymax)/2)*celly*celly
			if (r>(rscale*rscale)) then
		    	    if(chk.eq.0) then
		    	        chk=1
			        n=n+1
				nt=nt+1
			    end if
			    num(i+i1,j+j1,k+k1)=n
			else
			    nt=nt+1
			    if (chk.eq.0) n=nt
			    num(i+i1,j+j1,k+k1)=nt
			end if
		    end if		
		    end if
		end do
		end do
		end do
	end do
	end do
	end do
	n=nt

do k=1,n	
    do j=0,ymax
    do i=0,xmax
	if (num(i,j,0).eq.k) goto 777
    end do
    end do
    write(101,*) k
777 continue
end do
	

do j=0,ymax
do i=0,xmax
    write(100,'(I5)',ADVANCE='NO') num(i,j,0)
end do
    write(100,*)
end do	

end subroutine number_r


subroutine number_r2(masque,m,num,xmax,ymax,zmax,n,koeff,rscale,rcorn,cellx,celly,scx,scy,scz)
	integer :: xmax,ymax,zmax,i,j,k,n,i1,j1,k1,scx,scy,scz,chk,nt
	integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax)
	real, INTENT(IN) :: m(0:xmax,0:ymax,0:zmax,1:3)
	real :: der(0:xmax,0:ymax,0:zmax)
	integer :: masque1(0:xmax,0:ymax,0:zmax)
	integer, INTENT(OUT) ::num(0:xmax,0:ymax,0:zmax)
	real :: rscale,cellx,celly,r,t1(1:3),t2(1:3),derv(1:3),davg,dmax
	real :: reff,koeff,rcorn
	integer:: rx,ry,rz

! in this version we determine the areas of maximum derivative that do not lie on the corners

	der=0
	dmax=0
	i1=0
	davg=0
	do i=1,xmax-1
	do j=1,ymax-1
	do k=0,zmax
	    if ((masque(i,j,k).ne.0).and.(masque(i,j+1,k).ne.0).and.(masque(i+1,j,k).ne.0).and.(masque(i,j-1,k).ne.0).and.(masque(i-1,j,k).ne.0)) then
		i1=i1+1
		
		t2(:)=m(i,j+1,k,:)
		t1(:)=m(i,j-1,k,:)
		derv=(t2-t1)/2
		der(i,j,k)=der(i,j,k)+sqrt(derv(1)*derv(1)+derv(2)*derv(2)+derv(3)*derv(3))
		
		t2(:)=m(i+1,j,k,:)
		t1(:)=m(i-1,j,k,:)
		derv=(t2-t1)/2
		der(i,j,k)=der(i,j,k)+sqrt(derv(1)*derv(1)+derv(2)*derv(2)+derv(3)*derv(3))
		if (der(i,j,k)>dmax) dmax=der(i,j,k)
		davg=davg+der(i,j,k)
	    end if
	end do
	end do
	end do
	davg=davg/i1

	masque1=0	

	do i=1,xmax-1
	do j=1,ymax-1
	do k=0,zmax
	    if ((masque(i,j,k).ne.0).and.(masque(i,j+1,k).ne.0).and.(masque(i+1,j,k).ne.0).and.(masque(i,j-1,k).ne.0).and.(masque(i-1,j,k).ne.0)) then
		if (der(i,j,k)>(koeff*(dmax-davg)+davg)) then
		    reff=rscale*(der(i,j,k)-dmax)/(davg-dmax)
		    rx=nint(reff/cellx)
		    ry=nint(reff/celly)
		    do i1=i-rx,i+rx
		    do j1=j-ry,j+ry
			if((i1<=xmax).and.(j1<=ymax).and.(i1>=0).and.(j1>=0)) then
			    if (masque(i1,j1,k).ne.0) then
				r=cellx*cellx*(i1-i)*(i1-i)+(j1-j)*(j1-j)*celly*celly
				if(r<=reff) masque1(i1,j1,k)=1
			    end if
			end if
		    end do
		    end do
		end if
	    end if
	end do
	end do
	end do



	do i=1,xmax-1
	do j=1,ymax-1
	do k=0,zmax
	    if ((masque(i,j,k).ne.0).and.((masque(i,j+1,k).eq.0).or.(masque(i+1,j,k).eq.0).or.(masque(i,j-1,k).eq.0).or.(masque(i-1,j,k).eq.0))) then
		    rx=nint(rcorn/cellx)
		    ry=nint(rcorn/celly)
		    do i1=i-rx,i+rx
		    do j1=j-ry,j+ry
			if((i1<=xmax).and.(j1<=ymax).and.(i1>=0).and.(j1>=0)) then
			    if (masque(i1,j1,k).ne.0) then
				r=cellx*cellx*(i1-i)*(i1-i)+(j1-j)*(j1-j)*celly*celly
				if(r<=rcorn) masque1(i1,j1,k)=0
			    end if
			end if
		    end do
		    end do
	    end if
	end do
	end do
	end do

	
	call savemasquet2(masque1,xmax,ymax,zmax,"masque1.txt")
	nt=0
	num=0
	do i=0,xmax,scx
	do j=0,ymax,scy
	do k=0,zmax,scz
	chk=0
	n=nt
		do i1=0,scx-1,1
		do j1=0,scy-1,1
		do k1=0,scz-1,1
! calculate the distance from the center
		    if((((i+i1)<=xmax).and.((j+j1)<=ymax).and.((k+k1)<=zmax))) then
		    if(masque(i+i1,j+j1,k+k1).NE.0) then
			if (masque1(i+i1,j+j1,k+k1).eq.0) then
		    	    if(chk.eq.0) then
		    	        chk=1
			        n=n+1
				nt=nt+1
			    end if
			    num(i+i1,j+j1,k+k1)=n
			else
			    nt=nt+1
			    if (chk.eq.0) n=nt
			    num(i+i1,j+j1,k+k1)=nt
			end if
		    end if		
		    end if
		end do
		end do
		end do
	end do
	end do
	end do
	n=nt

do k=1,n	
    do j=0,ymax
    do i=0,xmax
	if (num(i,j,0).eq.k) goto 777
    end do
    end do
    write(101,*) k
777 continue
end do
	

do j=0,ymax
do i=0,xmax
    write(100,'(I5)',ADVANCE='NO') num(i,j,0)
end do
    write(100,*)
end do	

end subroutine number_r2


subroutine deg(degr,masque,num,xmax,ymax,zmax,n,scx,scy,scz)
	integer :: n,chk
	integer, intent(out) ::degr(1:n)
	integer :: xmax,ymax,zmax,i,j,k,i1,j1,k1,scx,scy,scz,scn
	integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax)
	integer, INTENT(IN) ::num(0:xmax,0:ymax,0:zmax)

	degr=0
	do i=0,xmax
	do j=0,ymax
	do k=0,zmax
	    if(masque(i,j,k).NE.0) then
		degr(num(i,j,k))=degr(num(i,j,k))+1
	    end if
	end do
	end do
	end do
	
	do j=0,ymax
	do i=0,xmax
	    if(masque(i,j,0).NE.0) then
		write(110,'(I2)',ADVANCE='NO') degr(num(i,j,0))
	    else
		write(110,'(I2)',ADVANCE='NO') 0
	    end if		
	end do
	write(110,*)
	end do
!	do i=1,n
!	    write(111,*) degr(i)
!	end do	
	
end subroutine deg

subroutine calcmatrix(m,aij,h,mp,beta,masque,num,xmax,ymax,zmax,ms,matmax,ncells,nmodes,degr,w,modes,modesl)
    integer :: xmax,ymax,zmax,ncells,nmodes,matmax
    real :: ms(matmax),mp(3)
    real, INTENT (IN) ::  aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
    integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax),degr(1:ncells)
    real, INTENT(IN) :: h(0:xmax,0:ymax,0:zmax,1:3),m(0:xmax,0:ymax,0:zmax,1:3)
    real :: t1
    real :: a(1:(2*Ncells),1:(2*Ncells))
    real, INTENT(IN) :: beta
    real :: mte(1:3)
    integer :: epsilon(1:3,1:3,1:3),i,j,k,i2,j2,k2,ii,ii2,alpha,phi,be,ga
    real :: te(1:3,1:3),to(1:3,1:3)
    real :: at(1:3,1:3),at1(1:3,1:3)
    real :: wr(1:(2*ncells)),wi(1:(2*ncells)),ztemp(1:(2*Ncells),1:(2*Ncells)),ztempl(1:(2*Ncells),1:(2*Ncells)),temp
    complex :: w(1:nmodes),modes(1:ncells,1:2,1:nmodes),modesl(1:ncells,1:2,1:nmodes)
    integer :: ilo,ihi,iwork(1:1),info
    real :: ctime,ctime2
    real :: work(1:(50*ncells)),rwork(1:1),scale(1:(2*ncells)),abnrm,rconde(1:(2*ncells)),rcondv(1:(2*ncells))
    integer :: n
!    real :: work(1:(6*n)),rwork(1:1),zl(1:1),scale(1:(2*n)),abnrm,rconde(1:(2*n)),rcondv(1:(2*ncells))

    n=ncells
    
    epsilon=0

    epsilon(1,2,3)=1
    epsilon(3,1,2)=1
    epsilon(2,3,1)=1

    epsilon(1,3,2)=-1	
    epsilon(3,2,1)=-1
    epsilon(2,1,3)=-1
    
!    call calcheff(heff,m,h,masque,xmax,ymax,zmax,ms,matmax,beta,mp)
    call CPU_TIME(ctime)
    a=0
    do i=0,xmax,1
    do j=0,ymax,1
    do k=0,zmax,1
    if (masque(i,j,k).NE.0) then
        ii=num(i,j,k)
	mte(1:3)=m(i,j,k,1:3)
	call calcmatr(mte,at,1)
	
	t1=0
	do i2=1,3
	    t1=t1+m(i,j,k,i2)*mp(i2)
	end do
	t1=t1/ms(masque(i,j,k))
		
	do i2=0,xmax,1
	do j2=0,ymax,1
	do k2=0,zmax,1
	if (masque(i2,j2,k2).NE.0) then 
	    ii2=num(i2,j2,k2)
	    mte(1:3)=m(i2,j2,k2,1:3)
	    call calcmatr(mte,at1,0)
	    te=0
	    to=0
! calculating the matrix elements
	    
!	    if ((i.NE.i2).or.(j.NE.j2).or.(k.NE.k2)) then
		do alpha=1,3,1
		do phi=1,3,1
		do be=1,3,1
		do ga=1,3,1
		    te(alpha,phi)=te(alpha,phi)+epsilon(alpha,be,ga)*m(i,j,k,be)*aij(i-i2,j-j2,k-k2,ga,phi,masque(i2,j2,k2))
		end do
		end do
		end do
		end do
!	    end if
		
	    if ((i.eq.i2).and.(j.eq.j2).and.(k.eq.k2)) then	    
		do alpha=1,3,1
		do phi=1,3,1
		do ga=1,3,1
		    te(alpha,phi)=te(alpha,phi)+epsilon(alpha,phi,ga)*h(i,j,k,ga)
		end do
		end do
		end do
	    end if

! converting to the local system of coordinates
	    to=te
	    do alpha=1,3,1
	    do phi=1,3,1
	    do be=1,3,1
	    do ga=1,3,1
		to(alpha,phi)=to(alpha,phi)+(beta*epsilon(alpha,be,ga)*m(i,j,k,be)*te(ga,phi)/ms(masque(i,j,k)))
	    end do
	    end do
	    end do
	    end do
	    
	    if ((i.eq.i2).and.(j.eq.j2).and.(k.eq.k2)) then	    
		do alpha=1,3
		    to(alpha,alpha)=to(alpha,alpha)-t1
		end do
	    end if
	    
	    te=0
	    	    
	    do alpha=1,3,1
	    do phi=1,3,1
	    do be=1,3,1
	    do ga=1,3,1
		te(alpha,phi)=te(alpha,phi)+at(alpha,be)*to(be,ga)*at1(ga,phi)
	    end do
	    end do
	    end do
	    end do

	    do be=1,2,1
	    do ga=1,2,1
		a(2*ii-2+be,2*ii2-2+ga)=a(2*ii-2+be,2*ii2-2+ga)+te(be,ga)
	    end do
	    end do
	end if
	end do
	end do
	end do
    end if
    end do
    end do
    end do
    
! now we perform renormalization - remember that different cells have different number of elements

    do ii=1,n,1
    do be=0,1,1
	a(2*ii-1+be,1:(2*N))=a(2*ii-1+be,1:(2*N))/real(degr(ii))
    end do
    end do
    
!    do ii=1,n,1
!    do be=0,1,1
!	write(15,*) ii,be,a(2*ii-1+be,5)
!    end do
!    end do
!    write(15,*) a(100,100),a(1,1),a(200,59)

    call CPU_TIME(ctime2)
	write(*,*) "matrix prepared in ", ctime2-ctime
    
! now we solve this matrix
!DEC$ IF (rflag.eq.4)
    call sgeevx('B','V','V','N',2*n,a,2*n,wr,wi,ztempl,2*n,ztemp,2*n,ilo,ihi,scale,abnrm,rconde,rcondv,work,50*n,iwork,info)
!DEC$ ELSE
    call dgeevx('B','V','V','N',2*n,a,2*n,wr,wi,ztempl,2*n,ztemp,2*n,ilo,ihi,scale,abnrm,rconde,rcondv,work,50*n,iwork,info)
!DEC$ ENDIF    
    call CPU_TIME(ctime)
    write(*,*) "matrix solved in ",ctime-ctime2
    call sort(ztemp,modes,wr,wi,w,ncells,nmodes)
    call sort(ztempl,modesl,wr,wi,w,ncells,nmodes)

end subroutine calcmatrix

subroutine calcmatr(m,at,tm)
	integer :: i,j,tm
	real, INTENT(IN) :: m(1:3)
	real :: tempe,cosa,cosb,sina,sinb
	real ::ms
	real :: temp(1:3,1:3)
	real, INTENT(OUT) :: at(1:3,1:3)

		ms=sqrt(m(1)*m(1)+m(2)*m(2)+m(3)*m(3))
		if (m(3)>(0.9999999*ms)) then
			cosa=1
			sina=0
			cosb=1
			sinb=0
		end if

		if (m(3)<(-0.9999999*ms)) then
			cosa=1
			sina=0
			cosb=-1
			sinb=0
		end if

		if (abs(m(3))<(0.9999999*ms)) then
			tempe=sqrt(m(1)*m(1)+m(2)*m(2))
			cosa=m(1)/tempe
			sina=m(2)/tempe
			cosb=m(3)/ms
			sinb=tempe/ms
		end if

	
		at(1,1)=cosb*cosa
		at(2,1)=cosb*sina
		at(3,1)=-sinb
		at(1,2)=-sina
		at(2,2)=cosa
		at(3,2)=0
		at(1,3)=sinb*cosa
		at(2,3)=sinb*sina
		at(3,3)=cosb

		if (tm.eq.1) then
		do i=1,3,1
			do j=1,3,1
				temp(i,j)=at(j,i)
			end do
		end do
		at=temp
		end if

		

end subroutine calcmatr

subroutine getabs(c,w,n,omega,abse,maxa)
	integer :: maxa,n,i
	complex, INTENT(IN) :: w(1:n)
	real, INTENT(INOUT) :: omega,abse
	real :: t1,t2
	complex, INTENT(IN) :: c(1:n)
	complex, parameter :: im=(0,1)

	abse=0
	t2=0
	maxa=0
	DO i=1,n,1
		t1=abs(real(c(i)/(omega-w(i))))
		if (t1>t2) then
		    maxa=i
		    t2=t1
		end if
		abse=abse+t1
	end do
	abse=0.5*abse*omega
end subroutine getabs

subroutine getomegas(c,n,w,omegamax,omegamin,ratio)
	integer :: n,i
	complex, INTENT(IN) :: c(1:n)
	complex, INTENT(IN) :: w(1:n)
	real :: ratio,t1,t2
	real, INTENT(OUT) :: omegamax,omegamin
	
	t1=0
	do i=1,n,1
		if (abs(imag(c(i)))>t1) t1=abs(imag(c(i)))
	end do
		
	do i=1,n,1
		if (abs(imag(c(i)))>(t1/ratio)) then
			omegamin=real(w(i))
			EXIT
		end if
	end do

	do i=n,1,-1
		if (abs(imag(c(i)))>(t1/ratio)) then
			omegamax=real(w(i))
			EXIT
		end if
	end do

end subroutine getomegas

subroutine local_to_cart(m,masque,num,zin,zout,xmax,ymax,zmax,n)
	integer :: n,xmax,ymax,zmax,matmax,x,y,z,be,ga,nn,i,j
	complex, INTENT(IN) :: zin(1:n,1:2)
	complex, INTENT(OUT) :: zout(1:n,1:3)
	integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
	real, INTENT(IN) :: m(0:xmax,0:ymax,0:zmax,1:3)
	real :: mtemp(1:n,1:3),mt(1:3)
	real :: at(1:3,1:3),t1
	integer :: degr(1:n)
	
	mtemp=0
	zout=0
	degr=0
	nn=n

	do x=0,xmax,1
	do y=0,ymax,1
	do z=0,zmax,1	
	if (masque(x,y,z).NE.0) then
	    degr(num(x,y,z))=degr(num(x,y,z))+1
    	    mt(1:3)=m(x,y,z,1:3)
	    call calcmatr(mt,at,0)
	    do be=1,3,1
	    do ga=1,2,1
	    	zout(num(x,y,z),be)=zout(num(x,y,z),be)+at(be,ga)*zin(num(x,y,z),ga)
	    end do
	    end do
	end if
	end do
	end do
	end do
	
	do x=1,n
	    if (degr(x)>0) zout(x,1:3)=zout(x,1:3)/degr(x)
	end do
	
end subroutine local_to_cart

subroutine norm_vector(zin,n)
	integer :: i,j,n
	complex, INTENT(INOUT) ::zin(1:n,1:3)
	real :: t1

	t1=0
	do i=1,n,1
		do j=1,3,1
			t1=t1+real(zin(i,j)*conjg(zin(i,j)))			
		end do
	end do

	zin=zin/sqrt(t1)

end subroutine norm_vector

subroutine norm_vector2(zout,n,max,coord)
	integer :: i,j,n,coord
	complex, INTENT(INOUT) ::zout(1:n,1:3)
	real :: t1,max,t2

	t1=0
	do i=1,n,1
	    t2=real(zout(i,coord))*real(zout(i,coord))
	    if (t2>t1) t1=t2
	end do

	zout=zout/sqrt(t1)

end subroutine norm_vector2

subroutine calc_c(c,m,hrf,z,zl,masque,num,degr,xmax,ymax,zmax,ncells,nmodes)
    integer :: xmax,ymax,zmax,i,j,k,ii,ii2,alpha,be,ga,ncells,nmodes,nn
    complex, INTENT(OUT) :: c(1:nmodes)
    complex :: zin(1:ncells,1:2)
    complex :: zout(1:ncells,1:3),zoutl(1:ncells,1:3)
    complex,INTENT(IN) :: z(1:ncells,1:2,1:nmodes),zl(1:ncells,1:2,1:nmodes)
    integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax),degr(1:ncells)
    real, INTENT(IN) :: m(0:xmax,0:ymax,0:zmax,1:3)
    complex, INTENT(IN) :: hrf(0:xmax,0:ymax,0:zmax,1:3)
    complex, parameter :: im=(0,1)
    complex :: tt1,tt2,tt3
    integer :: epsilon(1:3,1:3,1:3)
	
    epsilon=0

    epsilon(1,2,3)=1
    epsilon(3,1,2)=1
    epsilon(2,3,1)=1

    epsilon(1,3,2)=-1	
    epsilon(3,2,1)=-1
    epsilon(2,1,3)=-1
	
! first calculate how many elements do we need

    c=0
    
    do ii=1,nmodes,1
	zin(1:ncells,1:2)=z(1:ncells,1:2,ii)
	call local_to_cart(m,masque,num,zin,zout,xmax,ymax,zmax,ncells)
	zin(1:ncells,1:2)=zl(1:ncells,1:2,ii)
	call local_to_cart(m,masque,num,zin,zoutl,xmax,ymax,zmax,ncells)
	call norm4(zout,zoutl,ncells)
	tt1=0
	tt2=0
	do i=0,xmax,1
	do j=0,ymax,1
	do k=0,zmax,1
	    if (masque(i,j,k).NE.0) then
		do alpha=1,3,1
		    tt3=0
			do be=1,3,1
			do ga=1,3,1
			    tt3=tt3+epsilon(alpha,be,ga)*m(i,j,k,be)*hrf(i,j,k,ga)
			end do
			end do
		    tt1=tt1-tt3*conjg(zoutl(num(i,j,k),alpha))
!		    tt1=tt1-tt3*conjg(zout(num(i,j,k),alpha))
		end do
		do ii2=1,3,1
    		    tt2=tt2+zout(num(i,j,k),ii2)*conjg(hrf(i,j,k,ii2))
		end do
	    end if
	end do
	end do
	end do
	    c(ii)=tt1*tt2
!	    c(ii)=tt1*tt2/nconst
	end do

end subroutine calc_c

subroutine norm_to_draw(z,rstep,N,phases,phi0)
	integer :: n,i,j,imax
	real :: rstep
	complex, INTENT(INOUT) :: z(1:N,1:2)
	real :: phases(1:N,1:4)
	complex, parameter :: im=(0,1)
	real :: rmax,phimax,phi0

	phi0=0
	call find_phase(z,N,phases,rmax,phimax)
	z=z*rstep/rmax
	z=z*exp(-im*(phimax+phi0))

!	call find_phase(z,N,phases,w,rmax,phimax)

end subroutine norm_to_draw

subroutine find_phase(z,N,phases,rmax,phimax)
	integer :: N,j,i,check
	complex, INTENT(IN) :: z(1:N,1:2)
	real, INTENT(INOUT) ::phases(1:N,1:4)
	real :: rmax,phimax,phi,dphi
	complex, parameter :: im=(0,1)
	real :: xt,yt,rt,rt0
	
	rmax=0
	dphi=0.01
	
	do j=1,N,1
	
	    call atg(phases(j,1),real(z(j,1)),real(z(j,2)))
! 4 is max, 3 is min, is init phase, 2 is the phase of max
	    check=2
	    phi=0
	    do while (check>0)
! calculate zero element
		xt=real(exp(-im*phi)*z(j,1))
		yt=real(exp(-im*phi)*z(j,2))
		rt0=sqrt(xt*xt+yt*yt)
		phi=phi+dphi
		xt=real(exp(-im*phi)*z(j,1))
		yt=real(exp(-im*phi)*z(j,2))
		rt=sqrt(xt*xt+yt*yt)

		if (rt<rt0) then 
		    do while (rt<rt0)
			rt0=rt
			phi=phi+dphi			
			xt=real(exp(-im*phi)*z(j,1))
			yt=real(exp(-im*phi)*z(j,2))
			rt=sqrt(xt*xt+yt*yt)
		    end do
		    phases(j,3)=rt0
		    check=check-1
		end if
		if (rt>rt0) then 
		    do while (rt>rt0)
			rt0=rt
			phi=phi+dphi			
			xt=real(exp(-im*phi)*z(j,1))
			yt=real(exp(-im*phi)*z(j,2))
			rt=sqrt(xt*xt+yt*yt)
		    end do
		    phases(j,4)=rt0
		    call atg(phases(j,2),xt,yt)
		    if(phases(j,4)>rmax) then
	    		rmax=phases(j,4)
			phimax=phi
		    end if
		end if
	    end do
	end do

end subroutine find_phase


subroutine print_slice(phase,n,i,masque,xmax,ymax,zmax,num,tp,c1,c2,c3,sc1,sc2,sc3,ident)
    integer :: n
    integer :: ident
    character(255) :: fname
    integer :: tp,c1,c2,c3,sc1,sc2,sc3
    integer :: xmax,ymax,zmax
    integer :: x,y,z,i
    integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
    real, intent(IN) :: phase(1:n,1:4)

    write(fname,'(I0,a1,I0,a1,I0,a4)') ident,"-",i,"s",tp,".dat"
    OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',FORM='FORMATTED')	
    if (tp.eq.3) then
	y=c2
	x=c1
        do z=0,zmax,sc3
	    if (masque(x,y,z).NE.0) then
		write(999,'(I6,4F12.6)') z,phase(num(x,y,z),1:4)
	    end if
	end do
    end if
    if (tp.eq.2) then
	z=c3
	x=c1
        do y=0,ymax,sc2
	    if (masque(x,y,z).NE.0) then
		write(999,'(I6,4F12.6)') y,phase(num(x,y,z),1:4)
	    end if
	end do
    end if
    if (tp.eq.1) then
	z=c3
	y=c2
        do x=0,xmax,sc1
	    if (masque(x,y,z).NE.0) then
		write(999,'(I6,4F12.6)') x,phase(num(x,y,z),1:4)
	    end if
	end do
    end if
    CLOSE(999)
    
end subroutine print_slice

subroutine print_angle(phase,n,i,masque,xmax,ymax,zmax,num,tp,c1,c2,c3,sc1,sc2,sc3,rp,ident)
    integer :: n
    integer :: ident
    character(255) :: fname
    real :: c1,c2,c3,r,rp,rp2
    integer :: tp
    integer :: xmax,ymax,zmax
    integer :: x,y,z,i,sc1,sc2,sc3
    integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
    real, intent(IN) :: phase(1:n,1:4)

    write(fname,'(I0,a1,I0,a1,I0,a4)') ident,"-",i,"a",tp,".dat"
    OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',FORM='FORMATTED')	
    rp2=rp+0.65
    
    if (tp.eq.3) then
!xy plane
	z=nint(c3)
	do x=0,xmax,sc1
        do y=0,ymax,sc2
	    if (masque(x,y,z).NE.0) then
		r=sqrt((x-c1)*(x-c1)+(y-c1)*(y-c1))
!		write(*,*) x,y,rp,r
		if((r<=rp2).and.(r>=rp)) then
		    call atg(r,real(x),real(y))
		    write(999,'(F9.6,4F12.6)') r,phase(num(x,y,z),1:4)
		end if
	    end if
	end do
	end do
    end if

    if (tp.eq.2) then
!xz plane
	y=nint(c2)
	do x=0,xmax,sc1
        do z=0,zmax,sc3
	    if (masque(x,y,z).NE.0) then
		r=sqrt((x-c1)*(x-c1)+(z-c3)*(z-c3))
		if((r<=rp2).and.(r>=rp)) then
		    call atg(r,real(x),real(z))
		    write(999,'(F9.6,4F12.6)') r,phase(num(x,y,z),1:4)
		end if
	    end if
	end do
	end do
    end if

    if (tp.eq.1) then
!yz plane
	x=nint(c1)
	do y=0,ymax,sc2
        do z=0,zmax,sc3
	    if (masque(x,y,z).NE.0) then
		r=sqrt((y-c2)*(y-c2)+(z-c3)*(z-c3))
		if((r<=rp2).and.(r>=rp)) then
		    call atg(r,real(y),real(z))
		    write(999,'(F9.6,4F12.6)') r,phase(num(x,y,z),1:4)
		end if
	    end if
	end do
	end do
    end if
    
    CLOSE(999)
    
end subroutine print_angle

subroutine print_modes(z,w,n,is,ie,masque,xmax,ymax,zmax,num,ident,sc1,sc2,sc3,c1,c2,c3,rp)
    integer :: xmax,ymax,zmax,n,is,ie,ident,sc1,sc2,sc3
    integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
    real :: phase(1:n,1:4),c1,c2,c3,rmax,phimax
    complex :: zout(1:n,1:2)
    complex :: w_c,w(1:n),z(1:n,1:2,1:n)
    integer :: i,j,rp
    integer :: rstep,lthick
    
    lthick=2
    rstep=20
    
    do i=is,ie,1
	zout(:,:)=z(:,:,i)
	w_c=w(i)
	call drawmode(zout,n,masque,xmax,ymax,zmax,num,rstep,ident,i,lthick)
	call norm_to_draw(zout,real(1),N,phase,real(0))
	call find_phase(zout,N,phase,rmax,phimax)
	do j=1,3,1
	    call print_angle(phase,n,i,masque,xmax,ymax,zmax,num,j,c1,c2,c3,sc1,sc2,sc3,rp,ident)
	    call print_slice(phase,n,i,masque,xmax,ymax,zmax,num,j,c1,c2,c3,sc1,sc2,sc3,ident)
	end do
    end do

end subroutine print_modes

subroutine print_phases(zz,w,ncells,nmodes,is,ie,masque,xmax,ymax,zmax,num,ident,sc1,sc2,sc3)
    integer :: xmax,ymax,zmax,ncells,nmodes,is,ie,ident,sc1,sc2,sc3
    integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
    real :: phase(1:ncells,1:4),c1,c2,c3
    complex :: zout(1:ncells,1:2)
    complex :: w_c,w(1:nmodes),zz(1:ncells,1:2,1:nmodes)
    integer :: i,j,x,y,z
    real :: rmax,phimax
    character(255) :: fname

    do i=is,ie,1
	zout(:,:)=zz(:,:,i)
	w_c=w(i)
	call norm_to_draw(zout,real(1),ncells,phase,real(0))
	call find_phase(zout,ncells,phase,rmax,phimax)
	write(fname,'(I0,a1,I0,a5)') ident,"-",i,"p.dat"
	OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',FORM='FORMATTED')    
	do x=0,xmax,sc1
	do y=0,ymax,sc2
	do z=0,zmax,sc3
	    if(masque(x,y,z).NE.0) then
		write(999,'(3I6,4F12.6)') x,y,z,phase(num(x,y,z),1:4)
	    end if
	end do
	end do
	end do    
	CLOSE(999)
    end do    

end subroutine print_phases
    
subroutine drawmode(zout,n,masque,xmax,ymax,zmax,num,rstep,ident,i,lthick)
    integer :: n,rstep,lthick,i,j
    integer :: scx,scy,scz
    real ::r
    complex :: zout(1:n,1:2)
    integer :: xmax,ymax,zmax,x,y,z
    integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
    real :: phase(1:n,1:4)
    integer :: ident,yoff
    character(255) :: fname
    integer :: rdist
    integer :: x1,x2,y1,y2
    real :: rmax,phimax
    
    call norm_to_draw(zout,real(rstep),N,phase,real(0))
    call find_phase(zout,N,phase,rmax,phimax)
    rdist=2*rstep+2

    write(fname,'(I0,a1,I0,a4)') ident,"-",i,".eps"
    OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',FORM='FORMATTED')	
	
    write(999,'(a23)') "%!PS-Adobe-3.0 EPSF-3.0"
    write(999,'(a14)',ADVANCE='NO') "%%BoundingBox:"
    x1=-50
    x2=50+(xmax+1)*rdist
    y1=-50
    y2=50+(zmax+1)*(ymax+1)*rdist+50
    write(999,'(4I8)') x1,y1,x2,y2
    write(999,'(I1)',ADVANCE='NO') lthick
    write(999,*) " setlinewidth"
	
! background color
    write(999,'(a17)') "0 0 0 setrgbcolor"
    write(999,'(I0,3I6,a9)') x1,y1,x2-x1,y2-y1," rectfill"

! writing procedure
    write(999,'(a12)') "/plotEllipse"
    write(999,'(a1)') "{"
    write(999,'(a23)') "255 255 255 setrgbcolor"
    write(999,'(a7)') "newpath"
    write(999,'(a12)') "cx cy moveto"
    write(999,'(a19)') "initx inity rlineto"
    write(999,'(a6)') "stroke"
    write(999,'(a5)') "gsave"
    write(999,'(a7)') "newpath"
    write(999,'(a20)') "cr cg cb setrgbcolor"
    write(999,'(a15)') "cx cy translate"
    write(999,'(a11)') "tilt rotate"
    write(999,'(a14)') "ellipt 1 scale"
    write(999,'(a21)') "0 0 maxaxis 0 360 arc"
    write(999,'(a6)') "stroke"    
    write(999,'(a8)') "grestore"    
    write(999,'(a5)') "} def"
    
    write(999,'(1I0)',ADVANCE='NO') 0
    write(999,'(1I7)',ADVANCE='NO') 0
    write(999,'(a10)') " translate"
    
    yoff=0
    
    do z=0,zmax
	do x=0,xmax
	do y=0,ymax
	    if (masque(x,y,z).NE.0) then
		j=num(x,y,z)
		write(999,*)
		write(999,'(a9,I6,a4)') "/maxaxis ", nint(phase(j,4))," def"
		if (phase(j,4)>(rstep/real(2))) then
		    write(999,'(a4,I6,a4)') "/cr ", nint(255*phase(j,4)/real(rstep))," def"  
		    write(999,'(a4,I6,a4)') "/cg ", 255-nint(255*phase(j,4)/real(rstep))," def"  
		    write(999,'(a4,I6,a4)') "/cb ", 0," def"  
		else
		    write(999,'(a4,I6,a4)') "/cr ",0," def"  
		    write(999,'(a4,I6,a4)') "/cg ", nint(255*phase(j,4)/real(rstep))," def"  
		    write(999,'(a4,I6,a4)') "/cb ", 255-nint(255*phase(j,4)/real(rstep))," def"  		
		end if
		if (phase(j,3).NE.0) then
		    write(999,'(a8,F9.6,a4)') "/ellipt ", phase(j,3)/phase(j,4)," def"  
		else
		    write(999,'(a8,F9.6,a4)') "/ellipt ",real(1)," def"  
		end if
		write(999,'(a6,F16.6,a4)') "/tilt ", (-phase(j,2)*180/3.14159)," def"  
		write(999,'(a4,I6,a4)') "/cx ", rdist*x," def"
		write(999,'(a4,I6,a4)') "/cy ",rdist*y+yoff ," def"  
		write(999,'(a7,I6,a4)') "/initx ",nint(real(zout(j,1)+0.5))," def"  
		write(999,'(a7,I6,a4)') "/inity ",nint(real(zout(j,2)+0.5))," def"  
		write(999,*)		
		write(999,'(a11)')	"plotEllipse"
		write(999,*)			    
	    end if
	end do
	end do
	yoff=yoff+ymax*rdist+50
    end do

end subroutine drawmode


subroutine drawmode_proj(zin,n,m,masque,ms,matmax,xmax,ymax,zmax,num,ident,i,phi0,coord)
    integer :: n,rstep,lthick,i,j,matmax
    integer :: scx,scy,scz
    real ::r,ms(matmax)
    complex :: zin(1:n,1:2),zout(1:n,1:3)
    integer :: xmax,ymax,zmax,x,y,z
    integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
    real:: m(0:xmax,0:ymax,0:zmax,1:3)
    real :: phase(1:n,1:4)
    integer :: ident,yoff
    character(255) :: fname
    integer :: rdist
    integer :: x1,x2,y1,y2,coord
    real :: rmax,phimax,temp,phi0,clr,brt

!
    rdist=1
    rstep=0
!
    call norm_to_draw(zin,ms(1)/real(10),N,phase,phi0)
    call local_to_cart(m,masque,num,zin,zout,xmax,ymax,zmax,n)
!    do z=0,zmax,scz
!    do x=0,xmax,scx
!    do y=0,ymax,scy
!        if (masque(x,y,z).NE.0) then
!	    temp=sqrt(real(zout(num(x,y,z),1))*real(zout(num(x,y,z),1))+real(zout(num(x,y,z),2))*real(zout(num(x,y,z),2))+real(zout(num(x,y,z),3))*real(zout(num(x,y,z),3)))
!	    temp=(1-sqrt(1-(temp/ms(masque(x,y,z)))))
!	    zout(num(x,y,z),1:3)=zout(num(x,y,z),1:3)-m(x,y,z,1:3)*temp
!	end if
!    end do
!    end do
!    end do
    call norm_vector2(zout,n,real(1),coord)


    write(fname,'(I0,a1,I0,a4)') ident,"-",i,".eps"
    OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',FORM='FORMATTED')	
	
    write(999,'(a23)') "%!PS-Adobe-3.0 EPSF-3.0"
    write(999,'(a14)',ADVANCE='NO') "%%BoundingBox:"
    x1=-rstep
    x2=(xmax+1)*rdist
    y1=-rstep
    y2=(zmax+1)*(ymax+1)*rdist
    if((zmax+1)>1) y2=y2+(zmax+1)*5
    write(999,'(4I8)') x1,y1,x2,y2
	
! writing procedure
    yoff=0
    
    do z=0,zmax
    do y=0,ymax
    do x=0,xmax
        if (masque(x,y,z).NE.0) then
	    j=num(x,y,z)
	    clr=0.67*((1-real(zout(j,coord)))/2)
!	    if(real(zout(j,coord))<=0) clr=-0.25*real(zout(j,coord))+0.42
!	    if(real(zout(j,coord))>0) clr=-0.25*real(zout(j,coord))+0.25
	    brt=abs(real(zout(j,coord)))
	    if (brt>1) brt=1
!	    write(11,'(F5.2,a1)',ADVANCE='NO') real(zout(j,coord))," "
	    write(999,'(F0.2,a3,F0.2,a12)') clr," 1 ",brt," sethsbcolor"
	    x1=rdist*x-rstep
	    y1=rdist*y+yoff-rstep
	    write(999,'(I0,3I6,a9)') x1,y1,rdist,rdist," rectfill"
	end if
    end do
!	    write(11,*)
    end do
    yoff=yoff+ymax*rdist+5
    end do

end subroutine drawmode_proj

subroutine atg(phi,xx,yy)
	REAL :: xx,yy,phi
	if (yy.eq.0) then 
		if (xx>0) phi=3.14159265/real(2)
		if (xx<0) phi=3.14159265+(3.14159265/real(2))
	else
		phi=atan(xx/yy)
		if (yy<0) phi=phi+3.14159265
		if ((yy>0).and.(xx<0)) phi=phi+(2*3.14159265)
	end if
end subroutine atg

subroutine sort(z,zout,wr,wi,w,ncells,nmodes)
    integer :: i,n,j,curi,ncells,nmodes
    real, intent(in) :: z(1:(2*ncells),1:(2*ncells)),wr(1:(2*ncells)),wi(1:(2*ncells))
    complex, intent(out) :: zout(1:ncells,1:2,1:nmodes),w(1:nmodes)
    real :: t1(1:(2*ncells),2),w_r,w_i,wmax
    complex :: w_c,t2(1:ncells,1:2)
    integer :: el(1:nmodes),k
    real :: wcur,wlast,flag

! sorts from lowest to highest eigenvalues , but does not normalizes eigenvectors.

! forms an array that shows how nmodes smallest >0 modes fill the matrix
    wlast=0
    el=-1
!    write(*,*) nmodes,ncells
    do i=1,nmodes 
        wcur=1E200
	do j=1,ncells   
! we need to make sure that the mode did not appear in 1:i-1 elements
! and that 
	    flag=0
	    do k=1,i-1
		if (j.eq.el(k)) flag=1
	    end do
	    call get_omega(wr,wi,j,ncells,w_c)
	    if ((flag.eq.0).and.(real(w_c)<wcur).and.(real(w_c)>=wlast).and.(real(w_c)>0)) then
		wcur=real(w_c)
		el(i)=j
	    end if
	end do
	wlast=wcur
    end do
!    write(*,*) wi
!    write(*,*)
!    do j=1,ncells
!	call get_omega(wr,wi,j,ncells,w_c)
!	write(*,*) j,real(w_c)
!    end do
!    do j=1,nmodes
!        write(*,*) j,el(j)
!    end do
    
    do k=1,nmodes,1
	i=el(k)
	do j=1,2,1
	    t1(:,j)=z(:,2*(i-1)+j)
	end do
	w_r=wr(2*i-1)
	w_i=wi(2*i-1)
	call get_row(t1,t2,w_r,w_i,w_c,ncells)
	zout(:,:,k)=t2(:,:)
	w(k)=w_c
!	write(*,*) k
!	write(*,*) w(k)
    end do
    
end subroutine sort

subroutine get_row(t1,t2,w_r,w_i,w_c,n)
    integer :: n
    real,intent(in) :: t1(1:(2*n),2),w_r,w_i
    complex,intent(out):: w_c,t2(1:n,1:2)
    complex, parameter :: im=(0,1)
    integer :: sgn
    integer :: i,j
    
    if (w_i>0) then 
	sgn=+1
    else
	sgn=-1
    end if
    
    w_c=sgn*w_i-im*w_r
    do i=1,n,1
	do j=1,2,1
	    t2(i,j)=t1(2*(i-1)+j,1)+im*sgn*t1(2*(i-1)+j,2)
	end do
    end do

end subroutine get_row

subroutine get_omega(w_r,w_i,i,n,w_c)
    integer :: n
    real,intent(in) :: w_r(1:n),w_i(1:n)
    complex,intent(out):: w_c
    complex, parameter :: im=(0,1)
    integer :: sgn
    integer :: i,j
    
    if (w_i(2*i-1)>0) then 
	sgn=+1
    else
	sgn=-1
    end if
    
    w_c=sgn*w_i(2*i-1)-im*w_r(2*i-1)

end subroutine get_omega


subroutine savemodest(modes,w,masque,xmax,ymax,zmax,num,ncells,nmodes,fname)
    integer :: ncells,nmodes,i,j,xmax,ymax,zmax,x,y,z
    integer, intent(in) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
    complex, intent(in) :: modes(1:ncells,1:2,1:nmodes),w(1:nmodes)
    character(255) :: fname

    OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',ACTION='WRITE',FORM='FORMATTED')

    do i=1,nmodes,1
    write(999,*) w(i)
    do x=0,xmax,1
    do y=0,ymax,1
    do z=0,zmax,1
	if(masque(x,y,z).NE.0) then
	    write(999,'(3I6,4F15.6)') x,y,z,real(modes(num(x,y,z),1,i)),imag(modes(num(x,y,z),1,i)),real(modes(num(x,y,z),2,i)),imag(modes(num(x,y,z),2,i))
	end if
    end do
    end do
    end do
    end do
    
CLOSE(999)

end subroutine savemodest

subroutine savemodes(z,w,ncells,nmodes,num,masque,xmax,ymax,zmax,fname)
	integer :: n,i,j,ii,ncells,nmodes
	complex, intent(in) :: z(1:ncells,1:2,1:nmodes),w(1:nmodes)
	character(255) :: fname
	integer :: xmax,ymax,zmax,x,y,zz
	integer, intent(in) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax)
	complex :: t1,t2
	complex, parameter :: im=(0,1)
	
	j=1	
	inquire(iolength=i) j,z(1,1,j),z(1,2,j)
	! 1 integer, 2 complex
	OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',ACTION='WRITE',FORM='UNFORMATTED',ACCESS='DIRECT',RECL=i)
	ii=0
! information
	ii=ii+1
	j=ncells
	t1=nmodes
	t2=0
	write(999,REC=ii) j,t1,t2
! first we save num
	do x=0,xmax
	do y=0,ymax
	do zz=0,zmax
	    if (masque(x,y,zz)>0) then
		ii=ii+1
		j=x
		t1=y+im*zz
		t2=num(x,y,zz)
		write(999,REC=ii) j,t1,t2
!		write(*,*) x,y,zz,num(x,y,zz)
!		write(*,*) masque(x,y,zz)
	    end if
	end do
	end do
	end do
	
	ii=ii+1
	j=-1
	t1=-1
	t2=-1
	write(999,REC=ii) j,t1,t2
	
	do i=1,nmodes,1
	ii=ii+1
	    write(999,REC=ii) i,w(i),w(i)
	    do j=1,ncells,1
		ii=ii+1
		write(999,REC=ii) j,z(j,1,i),z(j,2,i)
	    end do
	end do

CLOSE(999)

end subroutine savemodes

subroutine read_number(num,xmax,ymax,zmax,ncells,nmodes,fname)
    integer :: xmax,ymax,zmax,ncells,nmodes
    integer, intent(out) :: num(0:xmax,0:ymax,0:zmax)
    character(255) :: fname
    complex :: t1,t2
    integer :: i,j,ii,x,y,z
    
    inquire(iolength=i) j,t1,t2
    OPEN(UNIT=999,FILE=fname,STATUS='OLD',ACTION='READ',FORM='UNFORMATTED',ACCESS='DIRECT',RECL=i)    
	ii=0
	ii=ii+1
	read(999,REC=ii) j,t1,t2
	ncells=j
	nmodes=nint(real(t1))
	j=0
!	write(*,*) ncells,nmodes
	do while (j>=0)
	    ii=ii+1
	    read(999,REC=ii) j,t1,t2
	    if (j>=0) then
		x=j
		y=nint(real(t1))
		z=nint(imag(t1))
		num(x,y,z)=nint(real(t2))
!		write(*,*) x,y,z,num(x,y,z)
	    end if
	end do
    CLOSE(999)
    
end subroutine read_number

subroutine loadmodes(z,w,ncells,nmodes,fname)
	integer :: ncells,nmodes,i,j,ii,it
	complex, intent(out) :: z(1:ncells,1:2,1:nmodes),w(1:nmodes)
	character(255) :: fname
	complex :: t1,t2
	
	j=1
	inquire(iolength=i) j,z(1,1,j),z(1,2,j)
	OPEN(UNIT=999,FILE=fname,STATUS='OLD',ACTION='READ',FORM='UNFORMATTED',ACCESS='DIRECT',RECL=i)

	ii=0
	it=0
	do while (it>=0)
	    ii=ii+1
	    read(999,REC=ii) it,t1,t2
	end do
	
	do i=1,nmodes,1
	    ii=ii+1
	    read(999,REC=ii) it,w(i),w(i)
	    do j=1,ncells,1
		ii=ii+1
		read(999,REC=ii) it,z(j,1,i),z(j,2,i)
	    end do
	end do

    CLOSE(999)
end subroutine loadmodes

subroutine print_c(c,w,n,gyro,fname)
	integer :: n,i
	complex, intent(in) :: c(1:n),w(1:n)
	character(255) :: fname
	real :: gyro

	OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',ACTION='WRITE',FORM='FORMATTED')
	do i=1,n,1
		write(999,'(I5,2F20.6,2F28.4)') i,real(c(i)),imag(c(i)),gyro*real(w(i)),gyro*imag(w(i))
	end do

	CLOSE(999)

end subroutine print_c 

subroutine print_abs(c,w,omegastep,n,gyro,fname)
	integer :: n,i,maxa
	real :: omegastep,omegamax,omegamin,omega,ratio,abse,gyro
	complex, intent(in) :: c(1:n),w(1:n)
	character(255) :: fname

	ratio=100
	call getomegas(c,n,w,omegamax,omegamin,ratio)
	omegamax=1.5*omegamax
	omegamin=omegamin*0.7
	OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',ACTION='WRITE',FORM='FORMATTED')
	omega=omegamin
	do while(omega<omegamax)
		call getabs(c,w,n,omega,abse,maxa)
		write(999,*) gyro*omega,abse,maxa
		omega=omega+(omegastep/gyro)
	end do

	CLOSE(999)

end subroutine print_abs

subroutine scale_omega(w,n,gyro)
    integer :: n
    complex :: w(1:n)
    real :: gyro
    
    w=w*gyro

end subroutine scale_omega

subroutine t23(m,z,z2,masque,num,degr,xmax,ymax,zmax,ncells,nmodes,nn)
    integer :: xmax,ymax,zmax,i,j,k,ii,ii2,alpha,be,ga,ncells,nmodes,nn
    complex :: zin(1:ncells,1:2)
    complex :: zout(1:ncells,1:3)
    complex,INTENT(IN) :: z(1:ncells,1:2,1:nmodes)
    complex :: z2(1:ncells,1:3,1:nn)
    integer, INTENT(IN) :: masque(0:xmax,0:ymax,0:zmax),num(0:xmax,0:ymax,0:zmax),degr(1:ncells)
    real, INTENT(IN) :: m(0:xmax,0:ymax,0:zmax,1:3)
    complex, parameter :: im=(0,1)
    complex :: tt1,tt2,tt3
    integer :: epsilon(1:3,1:3,1:3)
	
! first calculate how many elements do we need

    do ii=1,nn,1
	zin(1:ncells,1:2)=z(1:ncells,1:2,ii)
	call local_to_cart(m,masque,num,zin,zout,xmax,ymax,zmax,ncells)
	call norm_vector(zout,ncells)
	z2(:,:,ii)=zout(:,:)
    end do

end subroutine t23

subroutine norm3(z,zl,n,nn)
    integer :: xmax,ymax,zmax,i,j,k,ii,ii2,alpha,be,ga,n,nn
    complex :: z(1:n,1:3,1:nn),zl(1:n,1:3,1:nn)
    complex :: tt1,tt2,tt3
	
! first calculate how many elements do we need
    do i=1,nn
	tt1=0
	do j=1,n
	do k=1,3
	    tt1=tt1+z(j,k,i)*conjg(zl(j,k,i))
	end do
	end do	
	z(:,:,i)=z(:,:,i)/sqrt(abs(tt1))
!	zl(:,:,i)=zl(:,:,i)/sqrt(abs(tt1))
	zl(:,:,i)=zl(:,:,i)*tt1/(abs(tt1)*sqrt(abs(tt1)))
    end do

end subroutine norm3

subroutine ort(z,zl,n,nn)
    integer :: xmax,ymax,zmax,i,j,k,ii,ii2,alpha,be,ga,n,nn
    complex :: z(1:n,1:3,1:nn),zl(1:n,1:3,1:nn)
    complex :: tt1,tt2,tt3
	
! first calculate how many elements do we need
    do i=1,nn
    do ii=1,nn
	tt1=0
	do j=1,n
	do k=1,3
	    tt1=tt1+z(j,k,i)*conjg(zl(j,k,ii))
	end do
	end do	
	write(2,'(2I3,2F7.3)') i,ii,tt1
    end do
    end do
    
    write(2,*) "now -k modes:"
    do i=1,nn
    do ii=1,nn
	tt1=0
	do j=1,n
	do k=1,3
	    tt1=tt1+conjg(z(j,k,i))*conjg(zl(j,k,ii))
	end do
	end do	
	write(2,'(2I3,2F7.3)') i,ii,tt1
    end do
    end do

end subroutine ort

subroutine norm4(z,zl,n)
    integer :: xmax,ymax,zmax,i,j,k,ii,ii2,alpha,be,ga,n
    complex :: z(1:n,1:3),zl(1:n,1:3)
    complex :: tt1,tt2,tt3
	
! first calculate how many elements do we need
	tt1=0
	do j=1,n
	do k=1,3
	    tt1=tt1+z(j,k)*conjg(zl(j,k))
	end do
	end do	
	z(:,:)=z(:,:)/sqrt(abs(tt1))
!	zl(:,:)=zl(:,:)/sqrt(abs(tt1))
	zl(:,:)=zl(:,:)*tt1/(abs(tt1)*sqrt(abs(tt1)))
!	nconst=tt1/abs(tt1)
end subroutine norm4
 